package authorizationheader

import (
	"encoding/base64"
	"fmt"
	"log"
)

type BasicAuthHeaderBuilder struct {
	username, password string
}

func (hb BasicAuthHeaderBuilder) Build(logger *log.Logger) (string, error) {
	return fmt.Sprintf("Basic %s", base64.StdEncoding.EncodeToString([]byte(fmt.Sprintf("%s:%s", hb.username, hb.password)))), nil
}

func NewBasicAuthHeaderBuilder(username, password string) BasicAuthHeaderBuilder {
	return BasicAuthHeaderBuilder{
		username: username,
		password: password,
	}
}
