package boshclient

import (
	"fmt"
	"log"
	"net/http"

	"github.com/pivotal-cf/on-demand-services-sdk/bosh"

	"gopkg.in/yaml.v2"
)

func (c *Client) Deploy(manifest bosh.BoshManifest, logger *log.Logger) (int, error) {
	manifestBytes, err := yaml.Marshal(manifest)
	if err != nil {
		return 0, fmt.Errorf("error marshalling manifest to yaml: %s", err)
	}
	return c.DeployRaw(manifestBytes, logger)
}

func (c *Client) DeployRaw(manifest []byte, logger *log.Logger) (int, error) {
	return c.postAndGetTaskIdFromBoshCheckingForErrors(
		fmt.Sprintf("%s/deployments", c.boshURL),
		http.StatusFound,
		manifest,
		"text/yaml",
		logger,
	)
}
