package boshclient

import (
	"fmt"
	"log"
	"net/http"
)

func (c *Client) GetDeployments(logger *log.Logger) ([]BoshDeployment, error) {
	logger.Println("getting deployments from bosh")

	var deployments []BoshDeployment
	url := fmt.Sprintf("%s/deployments", c.boshURL)
	if err := c.getDataFromBoshCheckingForErrors(url, http.StatusOK, &deployments, logger); err != nil {
		return nil, err
	}

	return deployments, nil
}
