package boshclient

import (
	"fmt"
	"log"
	"net/http"
	"strings"
)

func (c *Client) GetDirectorVersion(logger *log.Logger) (string, error) {
	var boshInfo BoshInfo

	err := c.getDataFromBoshCheckingForErrors(fmt.Sprintf("%s/info", c.boshURL), http.StatusOK, &boshInfo, logger)
	if err != nil {
		return "", err
	}

	longVersion := strings.Fields(boshInfo.Version)[0]
	splitVersion := strings.Split(longVersion, ".")[0:3]
	return strings.Join(splitVersion, "."), nil
}
