package boshclient

import (
	"encoding/json"
	"fmt"
	"log"
	"net/http"
)

func (c *Client) RunErrand(deploymentName, errandName string, logger *log.Logger) (int, error) {
	logger.Printf("running errand %s from deployment %s\n", errandName, deploymentName)
	errandBodyBytes, err := json.Marshal(ErrandRequest{KeepAlive: false})
	if err != nil {
		return 0, fmt.Errorf("error marshalling errand request to yaml: %s", err)
	}

	return c.postAndGetTaskIdFromBoshCheckingForErrors(
		fmt.Sprintf("%s/deployments/%s/errands/%s/runs", c.boshURL, deploymentName, errandName),
		http.StatusFound,
		errandBodyBytes,
		"application/json",
		logger,
	)
}

type ErrandRequest struct {
	KeepAlive bool `json:"keep-alive"`
}
