package boshclient_test

import (
	. "github.com/onsi/ginkgo"
	. "github.com/onsi/gomega"
	"github.com/pivotal-cf/on-demand-service-broker/mockbosh"
)

var _ = Describe("running errands", func() {
	var (
		actualErr      error
		taskIDToReturn = 5
		deploymentName = "deploymentName"
		errandName     = "errandName"
	)

	JustBeforeEach(func() {
		_, actualErr = c.RunErrand(deploymentName, errandName, logger)
	})

	Context("succesfully", func() {
		BeforeEach(func() {
			director.VerifyAndMock(
				mockbosh.Errand(deploymentName, errandName).RedirectsToTask(taskIDToReturn),
			)
		})

		It("invokes BOSH to queue up an errand", func() {
			director.VerifyMocks()
			Expect(actualErr).NotTo(HaveOccurred())
		})
	})

	Context("has an error", func() {
		BeforeEach(func() {
			director.VerifyAndMock(
				mockbosh.Errand(deploymentName, errandName).Fails("because reasons"),
			)
		})

		It("invokes BOSH to queue up an errand", func() {
			director.VerifyMocks()
			Expect(actualErr).To(HaveOccurred())
		})
	})
})
