package broker

import (
	"fmt"
	"log"
)

func (b *Broker) redeploy(instanceID, planID string, lastOperation OperationType, requestParams map[string]interface{}, previousPlanID *string, logger *log.Logger) (int, error) {
	deploymentName := deploymentName(instanceID)
	oldManifest, err := b.boshClient.GetManifestRaw(deploymentName, logger)
	if err != nil {
		return 0, err
	}

	if oldManifest == nil {
		return 0, NewDeploymentNotFoundError(fmt.Errorf("there is no old manifest, the instance must not exist"))
	}
	boshTaskID, _, err := b.deployer.Deploy(instanceID, planID, deploymentName, lastOperation, requestParams, oldManifest, previousPlanID, logger)
	if err != nil {
		return 0, err
	}

	return boshTaskID, nil
}
