package config_test

import (
	. "github.com/onsi/ginkgo"
	. "github.com/onsi/gomega"
	"github.com/pivotal-cf/on-demand-service-broker/broker"
)

var _ = Describe("CfMarketplaceService", func() {
	Context("FindPlanById", func() {
		It("returns plan if found", func() {
			service := broker.ServiceOffering{
				Plans: []broker.Plan{
					{
						ID:   "planId",
						Name: "planName",
					},
				},
			}
			Expect(service.FindPlanById("planId")).To(Equal(&broker.Plan{
				ID:   "planId",
				Name: "planName",
			}))
		})

		It("returns nil otherwise", func() {
			service := broker.ServiceOffering{Plans: []broker.Plan{}}
			Expect(service.FindPlanById("planId")).To(BeNil())
		})
	})

})
