package config

import (
	"fmt"
	"os"
)

func checkIsExecutableFile(path string) error {
	info, err := os.Stat(path)
	if err != nil {
		return err
	}

	if info.IsDir() {
		return fmt.Errorf("service adapter '%s' is a directory", path)
	}

	if !isExecutable(info) {
		return fmt.Errorf("service adapter '%s' is not executable", path)
	}

	return nil
}

func isExecutable(info os.FileInfo) bool {
	return info.Mode()&0500 == 0500
}
